config/routes.rb
Rails.application.routes.draw do
  
  devise_for :users, controllers: { registrations: "registrations" }
  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html

 unauthenticated do
  as :user do
    root :to => 'pages#home'
  end
 end
 
  authenticated do
      root :to => 'products#index'
  end

  root 'pages#home'
  get 'dashboard' => 'pages#dashboard'

  get 'contact' => 'pages#contact'

  get 'shopify/auth' => 'shopifys#auth'
  get 'shopify/install' => 'shopifys#install'


  resources :products
  resources :categories
  resources :charges

  get 'affiliate/home', to: 'affiliates#home'

  get 'unsubscribe', to: 'charges#endsubscription'

  get 'subscribe', to: 'charges#new'
  get 'profile', to: 'pages#profile'

  resources :users, except: [:new]
  resources :influencers 
  resources :audiences
  resources :faqs
  resources :engagements

  get 'pricing', to: 'pages#pricing'
  get 'login', to: 'sessions#new'
  post 'login', to: 'sessions#create'
  delete 'logout', to: 'sessions#destroy'

  get 'admin', to: 'pages#admin'
end

app/controllers/charges_controller.rb
class ChargesController < ApplicationController
    before_action :authenticate_user!
    
    def new
      if current_user.subscribed? 
        flash[:warning] = "You are already subscribed!"
        redirect_to root_path
      end

      if Affiliate.where(:email => current_user.email).blank? #check if request.env is even filled -.-
        @affiliate = Affiliate.new()
        @affiliate.ref = request.env['affiliate.tag']
        @affiliate.email = current_user.email
        @affiliate.save
      end 

    end
    
    def create
      # Amount in cents
      @amount = 1499
    
      customer = Stripe::Customer.create(
        :email => params[:stripeEmail],
        :source  => params[:stripeToken]
      )

    
      subscription = Stripe::Subscription.create(
        :customer => customer.id,
        :items => [
          {
            #:plan => "plan_DxBOyspDDcF2E0"
            :plan => "plan_F1wlP22wXm2xan",
          },
        ],
        :trial_from_plan => true
      )

      current_user.subscribed = true
      current_user.subscriptionid = subscription.id
      current_user.customerid = customer.id

      current_user.subscribed_until = nil
      current_user.save!

    rescue Stripe::CardError => e
      flash[:error] = e.message
      redirect_to subscribe_path
    end

    def endsubscription
      if current_user.subscribed?
        sub = Stripe::Subscription.retrieve(current_user.subscriptionid)
        sub.delete

        current_user.subscribed_until = Time.at(sub.current_period_end)
        current_user.save!

        flash[:success] = "You successfully canceled your subscription! You will still have access until your current subscription runs out."
        redirect_to profile_path
      else
        redirect_to subscribe_path
      end
    end


end

app/helpers/charges_helper.rb
module ChargesHelper
end

app/views/charges/create.html.erb
<div class="land-welcome-section">
  <div class="container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="col-md-6 col-md-offset-3">
            <h1 class="display-middle" style="color: #484848; font-size: 300%; font-weight: 700; letter-spacing: -1px;">Upgraded to <u>Premium</u></h1>
          </div>
        </div>
        <div class="row">
          <div class="col-md-6 col-md-offset-3">
           <h3 style="letter-spacing: -1px; margin-top: -5px;">Welcome to the Premium DropshipHero Experience!</h3>
           <%= link_to(root_path) do %> <button class="btn btn-hero">Search for Products</button> <% end %>
          
          </div>
        </div>

      </div>
    </div>
</div>

<script>
  fbq('track', 'Purchase', {
    value: 14.99,
    currency: 'USD',
    contents: [
        {
            id: 'Premium',
            quantity: 1
        }
    ],
    content_ids: 'Premium',
  });
</script>

<!-- Event snippet for DropshipHero Standard conversion page -->
<script>
  gtag('event', 'conversion', {
      'send_to': 'AW-778671427/_d8ZCIKdzZoBEMOqpvMC',
      'transaction_id': ''
  });
</script>

app/views/charges/new.html.erb
<div class="land-welcome-section">
  <div class="container">
    <div class="row">
      <div class="col-md-12">
        <div class="row">
          <div class="col-md-6 col-md-offset-3">
           <!-- <%= image_tag("crown.png", style: "width: 50px; margin-bottom: -80px; margin-top: 90px;") %> -->
            <h1 class="display-middle" style="color: #484848; font-size: 280%; font-weight: 700; letter-spacing: -1px;"><u>LAST STEP</u> before you can start your FREE Trial</h1>
          </div>
        </div>
        <div class="row">
          <div class="col-md-6 col-md-offset-3">
           <h3 style="letter-spacing: -1px; margin-top: -5px;">…and join over 950 successful Dropship Heros</h3>
           <p style="font-size: 110%;">Get the most out of DropshipHero with all features in one package! Cover the costs with just ONE sale a month.</p>
          <br>
           <h5 style="margin-top: -10px; margin-bottom: 20px;"><i class="fa fa-star" style="color: gold; font-size: 120%; display:inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star-half" style="color: gold; font-size: 120%; display: inline;"></i> &nbsp; <span style="color: #787878;">121 Reviews</span></h5>
          </div>
        </div>

      </div>

    <div class="col-md-12 header center" style="margin-bottom: 12px;">
    <%= form_tag charges_path do %>
      <article>
        <% if flash[:error].present? %>
          <div id="error_explanation">
            <p><%= flash[:error] %></p>
          </div>
        <% end %>
      </article>

      <div class="col-md-12">
        <script src="https://checkout.stripe.com/checkout.js" class="stripe-button"
                  data-key="<%= Rails.configuration.stripe[:publishable_key] %>"
                  data-description="Dropship Hero - Premium Plan"
                  data-amount=""
                  data-label="YES, Claim My Free Account Now!"
                  data-panel-label="Get Started"
                  data-email="<%= current_user.email %>"
                  data-locale="en"></script>
       <p style="color: #787878; font-size: 120%; margin-top: 4px;"> <span class="deal-type">OFFER</span> &nbsp;After Trial just 19.99$ / month <b>LIMITED TIME ONLY</b></p>
      </div>


    <div class="col-md-4 col-md-offset-2" style="margin-top: 40px;margin-bottom: 40px;">
      <ul style="list-style-type: none; padding-inline-start: 0px; font-size: 150%;">
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> Facebook Targeting </li>
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> Prewritten Ad Copies </li>
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> Video Ad Download</li>
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> 1-Click Store Import</li>
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> Instagram Influencer</li>
          <li><i class="fa fa-rocket" style="color: #ffa600;"></i> Google Trends Analytics</li>
          <br>
          <li> ...and so much more</li>

      <ul>
    </div>

    <div class="col-md-3 col-xs-12" style="margin-top: 40px;margin-bottom: 40px;"> 
      <%= image_tag("shopify_sales.png", style: "display: block; margin-top: auto; margin-bottom: auto; height: 200px;") %>
    </div>

    <div class="col-md-6 col-md-offset-3">
           <p style="font-size: 110%;">"It's wonderful man. The products are great and there is very detailed information about them too"</p>
           <br>
           <h5 style="margin-top: -10px; margin-bottom: 20px;"><i class="fa fa-star" style="color: gold; font-size: 120%; display:inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> &nbsp; <span style="color: #787878;"> Sebastian M.</span></h5>
    </div>

    <div class="col-md-6 col-md-offset-3" style="margin-top: 20px;">
           <p style="font-size: 110%;">Thank you so much! It is very useful and I saw so many products that I want to test."</p>
           <br>
           <h5 style="margin-top: -10px; margin-bottom: 20px;"><i class="fa fa-star" style="color: gold; font-size: 120%; display:inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> &nbsp; <span style="color: #787878;"> Lok I.</span></h5>
    </div>

    <div class="col-md-6 col-md-offset-3" style="margin-top: 20px;">
           <p style="font-size: 110%;">Completly transformed the way I think about product research. I am testing multiple products right now and immediatly saw results!"</p>
           <br>
           <h5 style="margin-top: -10px; margin-bottom: 20px;"><i class="fa fa-star" style="color: gold; font-size: 120%; display:inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> <i class="fa fa-star" style="color: gold; font-size: 120%; display: inline;"></i> &nbsp; <span style="color: #787878;"> Nicholas D.</span></h5>
    </div>

    <div class="col-md-12" style="margin-bottom: 60px; margin-top: 40px;">
        <script src="https://checkout.stripe.com/checkout.js" class="stripe-button"
              data-key="<%= Rails.configuration.stripe[:publishable_key] %>"
              data-description="Dropship Hero - Premium Plan"
              data-amount=""
              data-label="YES, Register Me Now! "
              data-panel-label="Get Started"
              data-email="<%= current_user.email %>"
              data-locale="en"></script>
        <p style="color: #787878; font-size: 120%; margin-top: 4px;"> <span class="deal-type">LIMITED TIME OFFER</span> &nbsp; After Trial just 19.99$ / month</p>

    </div>

  </div>



    <br><br>
  <% end %>
  </div>
  </div>
</div>